OpenJPEGImage Class Reference

`#include <OpenJPEGImage.h>`

Inheritance diagram for OpenJPEGImage:

## Public Member Functions

| OpenJPEGImage ()
| Constructor.
| OpenJPEGImage (const std::string &path)
| Constructor.
| OpenJPEGImage (const OpenJPEGImage &image)
| Copy Constructor.
| OpenJPEGImage (const IIPImage &image)
| Copy Constructor.
| ~OpenJPEGImage ()
| Destructor.
void | openImage ()
| Overloaded function for opening a TIFF image.
void | loadImageInfo (int x, int y)
| Overloaded function for loading JP2 image information.
void | closeImage ()
| Overloaded function for closing a JP2 image.
bool | regionDecoding ()
| Return whether this image type directly handles region decoding.
RawTile | getTile (int x, int y, unsigned int r, int l, unsigned int t)
| Overloaded function for getting a particular tile.
RawTile | getRegion (int ha, int va, unsigned int res, int layers, int x, int y, unsigned int w, unsigned int h)
| Overloaded function for returning a region from image.
Public Member Functions inherited from IIPImage
| IIPImage ()
| Default Constructor.
| IIPImage (const std::string &s)
| Constructer taking the image path as parameter.
| IIPImage (const IIPImage &image)
| Copy Constructor taking reference to another IIPImage object.
virtual | ~IIPImage ()
| Virtual Destructor.
void | Initialise ()
| Test the image and initialise some parameters.
void | swap (IIPImage &a, IIPImage &b)
| Swap function.
std::list< int > | getVerticalViewsList ()
| Return a list of available vertical angles.
std::list< int > | getHorizontalViewsList ()
| Return a list of horizontal angles.
const std::string & | getImagePath ()
| Return the image path.
const std::string | getFileName (int x, int y)
| Return the full file path for a particular horizontal and vertical angle.
ImageFormat | getImageFormat ()
| Get the image format.
void | updateTimestamp (const std::string &s)
| Get the image timestamp.
const std::string | getTimestamp ()
| Get a HTTP RFC 1123 formatted timestamp.
bool | set ()
| Check whether this object has been initialised.
void | setFileSystemPrefix (const std::string &prefix)
| Set a file system prefix for added security.
void | setFileNamePattern (const std::string &pattern)
| Set the file name pattern used in image sequences.
unsigned int | getNumResolutions ()
| Return the number of available resolutions in the image.
unsigned int | getNumBitsPerPixel ()
| Return the number of bits per pixel for this image.
unsigned int | getNumChannels ()
| Return the number of channels for this image.
float | getMinValue (int n=0)
| Return the minimum sample value for each channel.
float | getMaxValue (int n=0)
| Return the minimum sample value for each channel.
SampleType | getSampleType ()
| Return the sample format type.
unsigned int | getImageWidth (int n=0)
| Return the image width in pixels for a given resolution.
unsigned int | getImageHeight (int n=0)
| Return the image height in pixels for a given resolution.
unsigned int | getTileHeight ()
| Return the base tile height in pixels for a given resolution.
unsigned int | getTileWidth ()
| Return the base tile width in pixels.
ColourSpaces | getColourSpace ()
| Return the colour space for this image.
const std::string & | getMetadata (const std::string &index)
| Return image metadata.
virtual void | Load (const std::string &module)
| Load the appropriate codec module for this image type.
virtual const std::string | getDescription ()
| Return codec description: Overloaded by child class.
IIPImage & | operator= (IIPImage image)
| Assignment operator.

## Additional Inherited Members

Public Attributes inherited from IIPImage
std::vector< unsigned int > | image_widths
| The image pixel dimensions.
std::vector< unsigned int > | image_heights
unsigned int | tile_width
| The base tile pixel dimensions.
unsigned int | tile_height
ColourSpaces | colourspace
| The colour space of the image.
unsigned int | numResolutions
| The number of available resolutions in this image.
unsigned int | bpc
| The bits per channel for this image.
unsigned int | channels
| The number of channels for this image.
SampleType | sampleType
| The sample format type (fixed or floating point).
std::vector< float > | min
| The min and max sample value for each channel.
std::vector< float > | max
unsigned int | quality_layers
| Quality layers.
bool | isSet
| Indicate whether we have opened and initialised some parameters for this image.
int | currentX
| If we have an image sequence, the current X and Y position.
int | currentY
std::vector< unsigned int > | histogram
| Image histogram.
std::map< const std::string, std::string > | metadata
| STL map to hold string metadata.
time_t | timestamp
| Image modification timestamp.
Protected Attributes inherited from IIPImage
std::vector< int > | lut
| LUT.
unsigned int | virtual_levels
| Number of resolution levels that don't physically exist in file.
ImageFormat | format
| Return the image format e.g. tif.

## Detailed Description

Image class for JPEG 2000 Images: Inherits from IIPImage. Uses the OpenJPEG library.

## Constructor & Destructor Documentation

## OpenJPEGImage() [1/3]

OpenJPEGImage::OpenJPEGImage | ( | const std::string & | path | ) |

inline

Constructor.

Parameters

  path | image path

References IIPImage::IIPImage(), IIPImage::tile_width, and IIPImage::virtual_levels.

## OpenJPEGImage() [2/3]

OpenJPEGImage::OpenJPEGImage | ( | const OpenJPEGImage & | image | ) |

inline

Copy Constructor.

Parameters

  image | OpenJPEG object

References IIPImage::IIPImage(), and OpenJPEGImage().

## OpenJPEGImage() [3/3]

OpenJPEGImage::OpenJPEGImage | ( | const IIPImage & | image | ) |

inline

Copy Constructor.

Parameters

  image | IIPImage object

References IIPImage::IIPImage(), IIPImage::tile_width, and IIPImage::virtual_levels.

## Member Function Documentation

## closeImage()

void OpenJPEGImage::closeImage | ( |  | ) |

virtual

Overloaded function for closing a JP2 image.

Reimplemented from IIPImage.

Referenced by ~OpenJPEGImage().

## getRegion()

RawTile OpenJPEGImage::getRegion | ( | int | ha,
|  | int | va,
|  | unsigned int | res,
|  | int | layers,
|  | int | x,
|  | int | y,
|  | unsigned int | w,
|  | unsigned int | h )

virtual

Overloaded function for returning a region from image.

Parameters

  ha | horizontal angle
  va | vertical angle
  res | resolution
  layers | number of quality layers to decode
  x | x coordinate
  y | y coordinate
  w | width of region
  h | height of region

Returns
  a RawTile object

Reimplemented from IIPImage.

## getTile()

RawTile OpenJPEGImage::getTile | ( | int | x,
|  | int | y,
|  | unsigned int | r,
|  | int | l,
|  | unsigned int | t )

virtual

Overloaded function for getting a particular tile.

Parameters

  x | horizontal sequence angle
  y | vertical sequence angle
  r | resolution
  l | number of quality layers to decode
  t | tile number

Reimplemented from IIPImage.

## loadImageInfo()

void OpenJPEGImage::loadImageInfo | ( | int | x,
|  | int | y )

virtual

Overloaded function for loading JP2 image information.

Parameters

  x | horizontal sequence angle
  y | vertical sequence angle

Reimplemented from IIPImage.

## openImage()

void OpenJPEGImage::openImage | ( |  | ) |

virtual

Overloaded function for opening a TIFF image.

Reimplemented from IIPImage.

## regionDecoding()

bool OpenJPEGImage::regionDecoding | ( |  | ) |

inline virtual

Return whether this image type directly handles region decoding.

Reimplemented from IIPImage.

The documentation for this class was generated from the following file:

- OpenJPEGImage.h